
require "statistics2"

def getChiSqrScore (countNew,totalNew,countOld,totalOld)
  
  countNew = countNew.to_f
  countOld = countOld.to_f
  totalNew = totalNew.to_f
  totalOld = totalOld.to_f
  
  
  
  p = countNew/ totalNew
  q = countOld / totalOld
  
  if ( p < q )
    return 0
  end
  
  t = (countNew + countOld) / (totalOld + totalNew)
  
  if ( t == 0)
     return nil
  end
  
  v = countNew * Math::log(p/t) + countOld  * Math::log(q/t)
  
  if ( t == 1 )
    return Statistics2..chi2X_(1,2*v)
  end
  
  if ( p < 1)
    v = v + ((totalNew - countNew) * Math::log((1-p)/(1-t)))
  end
  
  if ( q < 1)
    v = v + ((totalOld - countOld) * Math::log((1-q)/(1-t)))
  end

  return Statistics2.chi2X_(1,2*v)
  
end


  